-- Defines the natural numbers and some functions over them.
-- Author :: Ulf Norell
-- Created:: 2004-12-06

-- # import Bool

-- The natural numbers ----------------------------------------------------
data Nat : Set where
  zero  : Nat
  suc   : Nat -> Nat

-- Addition ---------------------------------------------------------------
infixl 8 +
(+) : Nat -> Nat -> Nat
n + 0       = n
n + suc  m  = suc  (n + m)

-- Division ---------------------------------------------------------------
half : Nat -> Nat
half 0              = 0
half 1              = 0
half (suc (suc n))  = half n + 1

-- Equal ------------------------------------------------------------------

-- (==) is already taken (and returns Prop rather than Bool)
eqNat : Nat -> Nat -> Bool
eqNat (0    ) (0    ) = true
eqNat (suc n) (0    ) = false
eqNat (0    ) (suc m) = false
eqNat (suc n) (suc m) = eqNat n m

-- Comparisons ------------------------------------------------------------
(<=) : Nat -> Nat -> Bool
0 <= m            = true
suc  n <= 0       = false
suc  n <= suc  m  = n <= m

(>=) : Nat -> Nat -> Bool
n >= m = m <= n

