{-| Abstracting a value @w@ from another value @v@ is the process of
    finding a function @f@ such that @f w = v@.
-}

module TypeChecker.Abstraction where

import Control.Monad.State

import Syntax.Internal
import Syntax.Values

import TypeChecker.UnfoldConstants
import TypeChecker.Universes
import TypeChecker.Values
import TypeChecker.Abstractions

import Utils.Monads
--import Utils.Debug

-- * Abstraction

{-# DEPRECATED abstract, (===) "currently broken" #-}

-- TODO: why does abstract look at so many types?
--       (try to put bottoms for the types)
-- | We should probably order the results cleverly.
abstract :: Value -> Value -> [Value -> Value]
abstract w v = []
{-
abstract w v = evalState (abstr w v) 0
    where
	abstr w v =
	    ifM (valueType w `subtype'` valueType v &&& v `equal` w)
		(return [ id, const v ])
	    $ case unfoldConstants v of
		VApp v v'	->
		    do	fs <- abstr w v
			gs <- abstr w v'
			return [ \v -> f v `vApp` g v | f <- fs, g <- gs ]
		VPair v v' t	->
		    do	fs <- abstr w v
			gs <- abstr w v'
			return [ \v -> VPair (f v) (g v) t | f <- fs, g <- gs ]
		VProj v p	->
		    do	fs <- abstr w v
			return [ \v -> VProj (f v) p | f <- fs ]
		VLam cl		->
		    do	fs  <- abstrCl w cl
			return	[ \w -> VLam (f w)
				| f <- fs
				]
		VPi v' cl t	->
		    do	fs  <- abstr w v'
			gs  <- abstrCl w cl
			return	[ \w -> VPi (f w) (g w) t
				| f <- fs, g <- gs
				]
		VSigma x v y cl t    ->
		    do	fs <- abstr w v
			gs <- abstrCl w cl
			return	[ \w -> VSigma x (f w) y (g w) t
				| f <- fs, g <- gs
				]
		v -> return [ const v ]
	    where
		abstrCl w cl =
		    do	fs <- abstr w (clBody cl)
			return  [ \w -> Cl (clName cl) (clType cl) (f w)
				| f <- fs
				]
-}
-- * Equality
{-
freshValue t =
    do	n <- get
	put (n + 1)
	return $ VId ("@" ++ show n) t

infixr 2 &&&
(&&&) :: Monad m => m Bool -> m Bool -> m Bool
m1 &&& m2 = ifM m1 m2 (return False)

-- TODO: Can we get rid of this and use the TypeChecker.Equality?

(=<=) :: Value -> Value -> Bool
v =<= w	= evalState (v `subtype'` w) 0

subtype' v w =
    case (unfoldConstants v, unfoldConstants w) of
	(VSort s1, VSort s2)		    -> return (s1 <= s2)
	_   | valueType v =<= valueType w   -> v `subtype` w
	    | otherwise			    -> return False

v `subtype` w = unfoldConstants v =<=* unfoldConstants w

VSort s1 =<=* VSort s2 = return (s1 <= s2)

VDef x _ =<=* VDef y _
    | x == y	= return True

-- ? Alternative: v === w, theoretical implications ?
VPi v f _ =<=* VPi w g _ =
    w `subtype` v &&&
	do  x <- freshValue w
	    clApp f x `subtype` clApp g x

VSigma x v y f _ =<=* VSigma x' w y' g _
    | x `lessLbl` x' && y `lessLbl` y' =
	v `subtype` w &&&
	    do	x <- freshValue v
		clApp f x `subtype` clApp g x
    where
	lessLbl _ "_"	= True
	lessLbl x y	= x == y

v =<=* w = v `equal` w


-}
(===) :: Value -> Value -> Bool
v === w = False --evalState (equal v w) 0
{-
equal :: Value -> Value -> State Int Bool

v1 `equal` v2 = unfoldConstants v1 ==* unfoldConstants v2

VDef x _    ==* VDef y _    = return (x == y)
VId x _	    ==* VId y _	    = return (x `eqVar` y)
    where
	"_" `eqVar` _	= False
	_ `eqVar` "_"	= False
	x `eqVar` y	= x == y

VLam f ==* VLam g =
    do	x <- freshValue (clType f)
	clApp f x `equal` clApp g x

VLam f ==* u = 
    do	x <- freshValue (clType f)
	clApp f x `equal` vApp u x

u ==* VLam f =
    do	x <- freshValue (clType f)
	VApp u x `equal` clApp f x

VPair v w _ ==* VPair v' w' _ =
    v `equal` v' &&& w `equal` w'

u ==* VPair v w _ =
    vProj u VFst `equal` v &&& vProj u VSnd `equal` w

VPair v w _ ==* u =
    v `equal` vProj u VFst &&& w `equal` vProj u VSnd

VProj v p ==* VProj w q
    | p == q	= v `equal` w

VPi v f _ ==* VPi w g _ =
    v `equal` w &&& do	x <- freshValue v
			clApp f x `equal` clApp g x

VSigma x v y f _ ==* VSigma x' w y' g _
    | x == x' && y == y'    =
	v `equal` w &&& do  x <- freshValue v
			    clApp f x `equal` clApp g x

VSort s1 ==* VSort s2 =
    return (s1 == s2)

VApp u1 v1 ==* VApp u2 v2 =
    u1 `equal` u2 &&& v1 `equal` v2

VTop _ ==* VTop _ = return True

u ==* v = return False
-}
